package com.ruoyi.common.utils.uuid;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.RandomUtil;
import com.ruoyi.common.utils.DateUtils;

import java.util.Date;

/**
 * ID生成器工具类
 *
 * @author ruoyi
 */
public class IdUtils
{
    /**
     * 获取随机UUID
     *
     * @return 随机UUID
     */
    public static String randomUUID()
    {
        return UUID.randomUUID().toString();
    }

    /**
     * 简化的UUID，去掉了横线
     *
     * @return 简化的UUID，去掉了横线
     */
    public static String simpleUUID()
    {
        return UUID.randomUUID().toString(true);
    }

    /**
     * 获取随机UUID，使用性能更好的ThreadLocalRandom生成UUID
     *
     * @return 随机UUID
     */
    public static String fastUUID()
    {
        return UUID.fastUUID().toString();
    }

    /**
     * 简化的UUID，去掉了横线，使用性能更好的ThreadLocalRandom生成UUID
     *
     * @return 简化的UUID，去掉了横线
     */
    public static String fastSimpleUUID()
    {
        return UUID.fastUUID().toString(true);
    }

    /**
     * 生成用户登录标识
     * @return 结果
     */
    public static String getUserLoginToken(){
        return IdUtil.getSnowflake(1, 1).nextIdStr();
    }

    /**
     * 年月日时分秒 + 随机数
     *
     * length 位数
     * @return 结果
     */
    public static String getOrderNum(Integer length) {
        String time = DateUtils.format(new Date(), "yyMMddHHmmss");
        String randomStr = RandomUtil.randomNumbers(length);
        return time + randomStr;
    }

}
